'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _enzyme = require('enzyme');

var _fetchNormalizeData = require('fetch-normalize-data');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxSaga = require('redux-saga');

var _reduxSaga2 = _interopRequireDefault(_reduxSaga);

var _effects = require('redux-saga/effects');

var _watchDataActions = require('../watchDataActions');

var _watchDataActions2 = _interopRequireDefault(_watchDataActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(rootSaga); /* eslint-disable no-use-before-define */


var mockFirstFoos = [{ id: 'AE', text: 'My foo is here', type: 'good' }, { id: 'BF', test: 'My other foo also', type: 'bad' }];
var mockSecondFoos = [{ id: 'AG', text: 'My second foo is here', type: 'good' }, { id: 'BJ', test: 'My other second foo also', type: 'bad' }];

var sagaMiddleware = (0, _reduxSaga2.default)();
var storeEnhancer = (0, _redux.applyMiddleware)(sagaMiddleware);
function rootSaga() {
  return regeneratorRuntime.wrap(function rootSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.all)([(0, _watchDataActions2.default)({
            rootUrl: 'https://momarx.com'
          })]);

        case 2:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}
var rootReducer = (0, _redux.combineReducers)({ data: (0, _fetchNormalizeData.createDataReducer)({ foos: [] }) });

var Foos = function (_PureComponent) {
  _inherits(Foos, _PureComponent);

  function Foos() {
    _classCallCheck(this, Foos);

    return _possibleConstructorReturn(this, (Foos.__proto__ || Object.getPrototypeOf(Foos)).apply(this, arguments));
  }

  _createClass(Foos, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          apiPath = _props.apiPath,
          dispatch = _props.dispatch,
          handleFailExpectation = _props.handleFailExpectation;

      dispatch((0, _fetchNormalizeData.requestData)({
        apiPath: apiPath,
        handleFail: handleFailExpectation,
        handleSuccess: function handleSuccess() {
          return dispatch((0, _fetchNormalizeData.requestData)({
            activityTag: 'secondFoos',
            apiPath: apiPath,
            stateKey: 'foos'
          }));
        },
        stateKey: 'foos'
      }));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          foos = _props2.foos,
          handleSuccessExpectation = _props2.handleSuccessExpectation;


      if (foos && foos.length) {
        handleSuccessExpectation(foos);
      }

      return _react2.default.createElement(
        _react.Fragment,
        null,
        (foos || []).map(function (foo) {
          return _react2.default.createElement(
            'div',
            { key: foo.id },
            foo.text
          );
        })
      );
    }
  }]);

  return Foos;
}(_react.PureComponent);

Foos.defaultProps = {
  foos: null,
  handleFailExpectation: function handleFailExpectation() {
    return {};
  },
  handleSuccessExpectation: function handleSuccessExpectation() {
    return {};
  }
};
Foos.propTypes = {
  apiPath: _propTypes2.default.string.isRequired,
  dispatch: _propTypes2.default.func.isRequired,
  foos: _propTypes2.default.arrayOf(_propTypes2.default.shape()),
  handleFailExpectation: _propTypes2.default.func,
  handleSuccessExpectation: _propTypes2.default.func
};
function mapStateToProps(state, ownProps) {
  return {
    foos: (state.data.foos || []).filter(function (foo) {
      return foo.type === ownProps.type;
    })
  };
}
var FoosContainer = (0, _reactRedux.connect)(mapStateToProps)(Foos);

jest.mock('fetch-normalize-data', function () {
  var actualModule = jest.requireActual('fetch-normalize-data');
  return _extends({}, actualModule, {
    fetchData: function fetchData(url, config) {
      if (url === 'https://momarx.com/failFoos') {
        return {
          errors: [{ data: ['failed foos'] }],
          status: 400
        };
      }
      if (url === 'https://momarx.com/successFoos') {
        if (config.activityTag === 'secondFoos') {
          return {
            data: mockSecondFoos,
            status: 200
          };
        }
        return {
          data: mockFirstFoos,
          status: 200
        };
      }
      return actualModule.fetchData(url, config);
    }
  });
});

describe('redux-saga-data with Foos basic usage', function () {
  describe('request with success', function () {
    it('should render test component whith foo items', function (done) {
      // given
      var store = (0, _redux.createStore)(rootReducer, storeEnhancer);
      sagaMiddleware.run(rootSaga);
      var expectedFirstFoos = mockFirstFoos.filter(function (mockFoo) {
        return mockFoo.type === 'good';
      }).map(function (mockFoo) {
        return _extends({}, mockFoo, {
          __ACTIVITIES__: ['/successFoos']
        });
      });
      var expectedSecondFoos = mockSecondFoos.filter(function (mockFoo) {
        return mockFoo.type === 'good';
      }).map(function (mockFoo) {
        return _extends({}, mockFoo, {
          __ACTIVITIES__: ['secondFoos']
        });
      });
      var expectedFoos = [].concat(_toConsumableArray(expectedFirstFoos), _toConsumableArray(expectedSecondFoos));

      // when
      (0, _enzyme.mount)(_react2.default.createElement(
        _reactRedux.Provider,
        { store: store },
        _react2.default.createElement(FoosContainer, {
          apiPath: '/successFoos',
          handleSuccessExpectation: handleSuccessExpectation,
          type: 'good'
        })
      ));

      // then
      function handleSuccessExpectation(foos) {
        expect(foos).toStrictEqual(expectedFoos);
        done();
      }
    });
  });

  describe('request with fail', function () {
    it('should render test component whith no foo items', function (done) {
      // given
      var store = (0, _redux.createStore)(rootReducer, storeEnhancer);
      sagaMiddleware.run(rootSaga);

      // when
      (0, _enzyme.mount)(_react2.default.createElement(
        _reactRedux.Provider,
        { store: store },
        _react2.default.createElement(FoosContainer, {
          apiPath: '/failFoos',
          handleFailExpectation: handleFailExpectation
        })
      ));

      // then
      function handleFailExpectation(state, action) {
        var payload = action.payload;
        var errors = payload.errors;

        expect(errors).toHaveLength(1);
        expect(errors[0]).toStrictEqual({ data: ['failed foos'] });
        done();
      }
    });
  });
});