'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GLOBAL_SERVER_ERROR = undefined;
exports.handleServerError = handleServerError;

var _fetchNormalizeData = require('fetch-normalize-data');

var _effects = require('redux-saga/effects');

var _marked = /*#__PURE__*/regeneratorRuntime.mark(handleServerError);

var GLOBAL_SERVER_ERROR = exports.GLOBAL_SERVER_ERROR = 'Server error. Try to to refresh the page.';

function handleServerError(error, config) {
  var globalServerError, handleFail, errors, payload, state, failAction;
  return regeneratorRuntime.wrap(function handleServerError$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          globalServerError = config.globalServerError || GLOBAL_SERVER_ERROR;
          handleFail = config.handleFail;
          errors = [{
            global: [globalServerError]
          }, {
            data: [String(error)]
          }];
          payload = {
            errors: errors,
            ok: false,
            status: 500
          };
          _context.next = 6;
          return (0, _effects.put)((0, _fetchNormalizeData.failData)(payload, config));

        case 6:
          if (!handleFail) {
            _context.next = 13;
            break;
          }

          _context.next = 9;
          return (0, _effects.select)(function (s) {
            return s;
          });

        case 9:
          state = _context.sent;
          failAction = { config: config, payload: payload };
          _context.next = 13;
          return (0, _effects.call)(handleFail, state, failAction);

        case 13:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

exports.default = handleServerError;