'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GLOBAL_TIMEOUT_ERROR = undefined;
exports.handleTimeoutError = handleTimeoutError;

var _fetchNormalizeData = require('fetch-normalize-data');

var _effects = require('redux-saga/effects');

var _marked = /*#__PURE__*/regeneratorRuntime.mark(handleTimeoutError);

var GLOBAL_TIMEOUT_ERROR = exports.GLOBAL_TIMEOUT_ERROR = 'Server timeout';

function handleTimeoutError(config) {
  var globalTimeoutError, handleFail, errors, payload, state, failAction;
  return regeneratorRuntime.wrap(function handleTimeoutError$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          globalTimeoutError = config.globalTimeoutError || GLOBAL_TIMEOUT_ERROR;
          handleFail = config.handleFail;
          errors = [{
            global: [globalTimeoutError]
          }];
          payload = {
            errors: errors,
            ok: false,
            status: 504
          };
          _context.next = 6;
          return (0, _effects.put)((0, _fetchNormalizeData.failData)(payload, config));

        case 6:
          if (!handleFail) {
            _context.next = 13;
            break;
          }

          _context.next = 9;
          return (0, _effects.select)(function (s) {
            return s;
          });

        case 9:
          state = _context.sent;
          failAction = { config: config, payload: payload };
          _context.next = 13;
          return (0, _effects.call)(handleFail, state, failAction);

        case 13:
          throw Error(errors);

        case 14:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

exports.default = handleTimeoutError;