'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fromWatchRequestDataActions = undefined;

var _fetchNormalizeData = require('fetch-normalize-data');

var _effects = require('redux-saga/effects');

var _handleApiSuccess = require('./handleApiSuccess');

var _handleApiSuccess2 = _interopRequireDefault(_handleApiSuccess);

var _handleApiError = require('./errors/handleApiError');

var _handleApiError2 = _interopRequireDefault(_handleApiError);

var _handleTimeoutError = require('./errors/handleTimeoutError');

var _handleTimeoutError2 = _interopRequireDefault(_handleTimeoutError);

var _handleServerError = require('./errors/handleServerError');

var _handleServerError2 = _interopRequireDefault(_handleServerError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fromWatchRequestDataActions = exports.fromWatchRequestDataActions = function fromWatchRequestDataActions(configWithoutDefaultValues) {
  return (/*#__PURE__*/regeneratorRuntime.mark(function fetchToSuccessOrFailData(action) {
      var config, timeout, url, fetchDataMethod, delayed, payload, result, _payload, errors, status, isSuccess;

      return regeneratorRuntime.wrap(function fetchToSuccessOrFailData$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              config = (0, _fetchNormalizeData.getConfigWithDefaultValues)(Object.assign({}, configWithoutDefaultValues, action.config));
              timeout = config.timeout;
              url = (0, _fetchNormalizeData.getUrlFromConfig)(config);
              fetchDataMethod = config.fetchData || _fetchNormalizeData.fetchData;
              _context.prev = 4;
              delayed = void 0;
              payload = void 0;

              if (!timeout) {
                _context.next = 15;
                break;
              }

              _context.next = 10;
              return (0, _effects.race)({
                delayed: (0, _effects.delay)(timeout),
                payload: (0, _effects.call)(fetchDataMethod, url, config)
              });

            case 10:
              result = _context.sent;

              /* eslint-disable-next-line prefer-destructuring */
              payload = result.payload;
              /* eslint-disable-next-line prefer-destructuring */
              delayed = result.delayed;
              _context.next = 18;
              break;

            case 15:
              _context.next = 17;
              return (0, _effects.call)(fetchDataMethod, url, config);

            case 17:
              payload = _context.sent;

            case 18:
              _payload = payload, errors = _payload.errors, status = _payload.status;
              isSuccess = (0, _fetchNormalizeData.isSuccessStatus)(status);

              if (!isSuccess) {
                _context.next = 24;
                break;
              }

              _context.next = 23;
              return (0, _effects.call)(_handleApiSuccess2.default, payload, config);

            case 23:
              return _context.abrupt('return');

            case 24:
              if (!errors) {
                _context.next = 27;
                break;
              }

              _context.next = 27;
              return (0, _effects.call)(_handleApiError2.default, payload, config);

            case 27:
              if (!delayed) {
                _context.next = 30;
                break;
              }

              _context.next = 30;
              return (0, _effects.call)(_handleTimeoutError2.default, config);

            case 30:
              _context.next = 36;
              break;

            case 32:
              _context.prev = 32;
              _context.t0 = _context['catch'](4);
              _context.next = 36;
              return (0, _effects.call)(_handleServerError2.default, _context.t0, config);

            case 36:
            case 'end':
              return _context.stop();
          }
        }
      }, fetchToSuccessOrFailData, this, [[4, 32]]);
    })
  );
};

exports.default = fromWatchRequestDataActions;